local AddOn, NS = ...
local mathfloor = math.floor

function NS:StatusBar_SetValue(bar, value)
	if (value == 0) then value = .01 end
	value = value / 100
	if (value > 1) then value = 1 end
	if (bar.direction < 3) then
		bar:SetWidth(bar.length * value)
	else
		bar:SetHeight(bar.length * value)
	end
	if (bar.direction == 1) then
		bar:SetTexCoord(0, value, 0, 1)
	elseif (bar.direction == 2) then
		bar:SetTexCoord(value, 0, 0, 1)
	elseif (bar.direction == 3) then
		bar:SetTexCoord(0, 1, value, 0)
	elseif (bar.direction == 4) then
		bar:SetTexCoord(0, 1, 0, value)
	end
end

function NS:DUF_HonorBar_Update()
	if (DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.Honor].trackRep) then
		DUF_ReputationBar_Update(2)
		return
	end
	local Progress = NS.GetPVPRankProgress() * 100 --, 1, DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.Honor].width
	NS:StatusBar_SetValue(DUF_PlayerFrame_HonorBar_Bar, Progress)
	NS:StatusBar_SetValue(DUF_PlayerFrame_HonorBar_Bar2, Progress)
end

function DUF_ReputationBar_Update(bar)
	local _, _, min, max, value = GetWatchedFactionInfo()
	local percent
	if max - min ~= 0 then
		percent = (value - min) / (max - min) * 100
	else
		percent = 0
	end
	local frame, frame2, sbi
	if (bar == 1) then
		frame1 = DUF_PlayerFrame_XPBar.Bar1
		frame2 = DUF_PlayerFrame_XPBar.Bar2
		sbi = 3
	else
		frame1 = DUF_PlayerFrame_HonorBar.Bar1
		frame2 = DUF_PlayerFrame_HonorBar.Bar2
		sbi = 8
	end
	NS:StatusBar_SetValue(frame1, percent, 1, DUF_Settings[DUF_INDEX].player.StatusBar[sbi].width)
	NS:StatusBar_SetValue(frame2, percent, 1, DUF_Settings[DUF_INDEX].player.StatusBar[sbi].width)
end

-------------------------------------------------------*** End of locals ***-----------------------------------------

function NS:DUF_AltManaBar_Update_Display() 
--	local form = GetShapeshiftForm()
	local form = GetShapeshiftFormID()
	local bar = _G[DUF_FRAME_DATA["player"].frame.."_AltManaBar"]
	local txt = _G[DUF_FRAME_DATA["player"].frame.."_TextBox_11"]
	local barHide = DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.AltMana].hide
	local txtHide = DUF_Settings[DUF_INDEX].player.TextBox[11].hide
	local powerType = UnitPowerType("player")
--	local _, name
--	if form > 0 then
--		_, name = GetShapeshiftFormInfo(form)
--	end
    	if (NS.DUF_ISDRUID and (form == BEAR_FORM or form == CAT_FORM)) or NS.ALTPOWERTYPES[powerType] or DUF_OPTIONS_VISIBLE then
		if not DUF_OPTIONS_VISIBLE then
			NS.DUF_ISSHAPESHIFTED = 1
		end
--		if (not InCombatLockdown()) then
			if barHide then
	    			bar:Hide()
	    		else
--				NS:DUF_ManaBar_UpdateType(DUF_PlayerFrame, 7)
				bar:Show()
	    		end
			if txtHide then
		    		txt:Hide()
		    	else
		    		txt:Show()
		    	end
--		end
    	else
    		NS.DUF_ISSHAPESHIFTED = nil
--		if (not InCombatLockdown()) then
			txt:Hide()
			bar:Hide()
--		end
    	end
end

function NS:DUF_AltManaBar_Update(StatusBar)
	local powerType = UnitPowerType("player")
	if NS.DUF_ISDRUID or NS.ALTPOWERTYPES[powerType] then
		StatusBar.mana = StatusBar.altmana	
		StatusBar.manamax = StatusBar.altmanamax
		NS:DUF_ManaBar_Update(StatusBar, NS.Bar.AltMana)
	end
end

function NS:DUF_ManaBar_Update(StatusBar, id)
	local barId 
	if not id then
		barId = 2
	else
		barId = id
	end
	local MANABAR_SETTINGS = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[StatusBar.unit].index].StatusBar[barId] 
 	if ((not StatusBar.mana) or (not StatusBar.manamax) or StatusBar.manamax == 0) then
		if (MANABAR_SETTINGS.hideifnomana and (not DUF_OPTIONS_VISIBLE)) then
			_G[StatusBar:GetName().."_ManaBar"]:SetAlpha(0)
			return
		else
			if ((not MANABAR_SETTINGS.hide) and (not MANABAR_SETTINGS.mouseover)) then
				_G[StatusBar:GetName().."_ManaBar"]:SetAlpha(MANABAR_SETTINGS.alpha)
			else
				return
			end
			if (DUF_OPTIONS_VISIBLE) then
				StatusBar.mana = 100
				StatusBar.manamax = 100
				StatusBar.lastmana = 100
			else
				StatusBar.mana = 0
				StatusBar.manamax = 0
				StatusBar.lastmana = 0
			end
		end
	elseif ((not MANABAR_SETTINGS.hide) and (not MANABAR_SETTINGS.mouseover)) then
		if (barId == 2) then 
			_G[StatusBar:GetName().."_ManaBar"]:SetAlpha(MANABAR_SETTINGS.alpha)
		elseif (barId == 7) then
			_G[StatusBar:GetName().."_AltManaBar"]:SetAlpha(MANABAR_SETTINGS.alpha)
		end
	end
	if (not StatusBar.mana) then StatusBar.mana = 0 end
	local value
	if (StatusBar.manamax == 0) then
		value = StatusBar.mana * 100
	else
		value = StatusBar.mana / StatusBar.manamax * 100
	end
	local value2 = 0
	if (MANABAR_SETTINGS.fade and StatusBar.lastmana < StatusBar.manamax) then
		value2 = StatusBar.lastmana / StatusBar.manamax * 100
		if StatusBar.stacked then
			value2 = value2 - value
		end
	end
	if (StatusBar.manamax == 0) then
		value = 0
		value2 = 0
	end
	if (StatusBar.lastmana > StatusBar.mana and value2 > 0) then
		StatusBar.lastmanaalpha = 1
	end
	StatusBar.lastmana = StatusBar.mana
	local width = MANABAR_SETTINGS.width
	if (MANABAR_SETTINGS.resizemax and StatusBar.lastmanamax ~= StatusBar.manamax) then
		StatusBar.lastmanamax = StatusBar.manamax
		local percent = StatusBar.manamax / UnitPowerMax("player")
		width = width * percent
		local padding = MANABAR_SETTINGS.bgpadding * 2
		if (barId == 2) then 
			_G[StatusBar:GetName().."_ManaBar"].dynamicsize = percent
			_G[StatusBar:GetName().."_ManaBar"].Background:SetWidth(width + padding)
		elseif (barId == 7) then -- Fixed 5.3
			_G[StatusBar:GetName().."_AltManaBar"].dynamicsize = percent
			_G[StatusBar:GetName().."_AltManaBar"].Background:SetWidth(width + padding)
		end
	end
	if (MANABAR_SETTINGS.fill) then
		if (barId == 2) then 
			NS:StatusBar_SetValue(_G[StatusBar:GetName().."_ManaBar"].Bar1, 100 - value, 1, width)
			NS:StatusBar_SetValue(_G[StatusBar:GetName().."_ManaBar"].Bar2, 0, 1, width)
		elseif (barId == 7) then -- Fixed 5.3
			NS:StatusBar_SetValue(_G[StatusBar:GetName().."_AltManaBar"].Bar1, 100 - value, 1, width)
			NS:StatusBar_SetValue(_G[StatusBar:GetName().."_AltManaBar"].Bar2, 0, 1, width)
		end
	else
		if (barId == 2) then 
			NS:StatusBar_SetValue(_G[StatusBar:GetName().."_ManaBar"].Bar1, value, 1, width)
			NS:StatusBar_SetValue(_G[StatusBar:GetName().."_ManaBar"].Bar2, value2, 1, width)
		elseif (barId == 7) then -- Fixed 5.3
			NS:StatusBar_SetValue(_G[StatusBar:GetName().."_AltManaBar"].Bar1, value, 1, width)
			NS:StatusBar_SetValue(_G[StatusBar:GetName().."_AltManaBar"].Bar2, value2, 1, width)
		end
	end
end

function NS:DUF_ManaBar_UpdateType(StatusBar, id)
	local barId 
	if not id then
		barId = 2
	else
		barId = id
	end
	local MANABAR_SETTINGS = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[StatusBar.unit].index].StatusBar[barId] 
	local color
	if (StatusBar.manatype == Enum.PowerType.Mana) then --0
		color = MANABAR_SETTINGS.manacolor
	elseif (StatusBar.manatype == Enum.PowerType.Rage) then --1
		color = MANABAR_SETTINGS.ragecolor
	elseif (StatusBar.manatype == Enum.PowerType.Focus) then -- 2
		color = MANABAR_SETTINGS.focuscolor
	elseif (StatusBar.manatype == Enum.PowerType.Energy) then --3
		color = MANABAR_SETTINGS.energycolor
	elseif (StatusBar.manatype == Enum.PowerType.RunicPower) then --6
		color = MANABAR_SETTINGS.runicpowercolor
	elseif (StatusBar.manatype == Enum.PowerType.LunarPower) then  --8
		color = MANABAR_SETTINGS.lunarpowercolor
	elseif (StatusBar.manatype == Enum.PowerType.HolyPower) then  --9
		color = MANABAR_SETTINGS.holycolor
	elseif (StatusBar.manatype == Enum.PowerType.Maelstrom) then  --11
		color = MANABAR_SETTINGS.maelstrompower
	elseif (StatusBar.manatype == Enum.PowerType.Insanity) then  --13
		color = MANABAR_SETTINGS.insanitycolor
	elseif (StatusBar.manatype == Enum.PowerType.Fury) then  --17
		color = MANABAR_SETTINGS.furycolor
	end
	if (color) then
		if (barId == 2) then 
			_G[StatusBar:GetName().."_ManaBar"].manacolor = color
			_G[StatusBar:GetName().."_ManaBar"].Bar1:SetVertexColor(color.r, color.g, color.b)
 		elseif (barId == 7) then
			_G[StatusBar:GetName().."_AltManaBar"].manacolor = color
			_G[StatusBar:GetName().."_AltManaBar"].Bar1:SetVertexColor(color.r, color.g, color.b)
		end
	end
end

function NS:DUF_HealthBar_Update(StatusBar)
	if ((not StatusBar.health) or (not StatusBar.healthmax) or StatusBar.healthmax == 0) then return end
	local value = StatusBar.health / StatusBar.healthmax * 100
	local value2 = 0
	if (DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[StatusBar.unit].index].StatusBar[NS.Bar.Health].fade and StatusBar.lasthealth < StatusBar.healthmax) then
		value2 = StatusBar.lasthealth / StatusBar.healthmax * 100		
		if StatusBar.stacked then
			value2 = value2 - value
		end
	end
	if (StatusBar.lasthealth > StatusBar.health and value2 > 0) then
		StatusBar.lasthealthalpha = 1
	end
	local width = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[StatusBar.unit].index].StatusBar[NS.Bar.Health].width
	if (DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[StatusBar.unit].index].StatusBar[NS.Bar.Health].resizemax and StatusBar.lasthealthmax ~= StatusBar.healthmax) then
		StatusBar.lasthealthmax = StatusBar.healthmax
		local percent = StatusBar.healthmax / UnitHealthMax("player")
		width = width * percent
		local padding = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[StatusBar.unit].index].StatusBar[NS.Bar.Health].bgpadding * 2
		_G[StatusBar:GetName().."_HealthBar"].dynamicsize = percent
		_G[StatusBar:GetName().."_HealthBar"].Background:SetWidth(width + padding)
	end
	StatusBar.lasthealth = StatusBar.health
	if (DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[StatusBar.unit].index].StatusBar[NS.Bar.Health].fill) then
		NS:StatusBar_SetValue(_G[StatusBar:GetName().."_HealthBar"].Bar1, 100 - value, 1, width)
		NS:StatusBar_SetValue(_G[StatusBar:GetName().."_HealthBar"].Bar2, 0, 1, width)
	else
		NS:StatusBar_SetValue(_G[StatusBar:GetName().."_HealthBar"].Bar1, value, 1, width)
		NS:StatusBar_SetValue(_G[StatusBar:GetName().."_HealthBar"].Bar2, value2, 1, width)
	end
end

function NS:DUF_PetXPBar_Update()
	local current, needed = NS.GetPetExperience()
	local percent
	if (needed == 0) then
		percent = current * 100
	else
		percent = current / needed * 100
	end
	if (needed == 0) then
		percent = 0
	end
	local Width = DUF_Settings[DUF_INDEX].pet.StatusBar[NS.Bar.XP].width
	NS:StatusBar_SetValue(DUF_PetFrame_XPBar.Bar1, percent, 1, Width)
	NS:StatusBar_SetValue(DUF_PetFrame_XPBar.Bar2, percent, 1, Width)
end

function NS:DUF_TargetHealthBar_Update(StatusBar)
	local BAR_SETTINGS = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[StatusBar.unit].index].StatusBar[NS.Bar.TargetHealth]
	if ((not StatusBar.healthtarget) or (not StatusBar.healthmaxtarget) or StatusBar.healthmaxtarget == 0) then
		if (DUF_OPTIONS_VISIBLE) then
			if (not BAR_SETTINGS.hide) then
				_G[StatusBar:GetName().."_TargetHealthBar"]:SetAlpha(BAR_SETTINGS.alpha)
			else
				return
			end
			StatusBar.healthtarget = 100
			StatusBar.healthmaxtarget = 100
		else
			_G[StatusBar:GetName().."_TargetHealthBar"]:SetAlpha(0)
			return
		end
	end
	if (not StatusBar.unit) then return end
	if ( (not DL_UnitName(StatusBar.unit.."target")) and (not DUF_OPTIONS_VISIBLE) ) then
		_G[StatusBar:GetName().."_TargetHealthBar"]:SetAlpha(0)
		return
	elseif (not BAR_SETTINGS.hide) then
		_G[StatusBar:GetName().."_TargetHealthBar"]:SetAlpha(BAR_SETTINGS.alpha)
	end
	local value = StatusBar.healthtarget / StatusBar.healthmaxtarget * 100
	if (StatusBar.healthmaxtarget == 0) then
		value = 100
	end
	local width = BAR_SETTINGS.width
	if (BAR_SETTINGS.fill) then
		NS:StatusBar_SetValue(_G[StatusBar:GetName().."_TargetHealthBar"].Bar1, 100 - value, 1, width)
		NS:StatusBar_SetValue(_G[StatusBar:GetName().."_TargetHealthBar"].Bar2, 0, 1, width)
	else
		NS:StatusBar_SetValue(_G[StatusBar:GetName().."_TargetHealthBar"].Bar1, value, 1, width)
		NS:StatusBar_SetValue(_G[StatusBar:GetName().."_TargetHealthBar"].Bar2, 0, 1, width)
	end
end

function NS:DUF_TargetManaBar_Update(StatusBar)
	local BAR_SETTINGS = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[StatusBar.unit].index].StatusBar[NS.Bar.TargetPower]
	if ((not StatusBar.manatarget) or (not StatusBar.manamaxtarget) or StatusBar.manamaxtarget == 0) then
		if (BAR_SETTINGS.hideifnomana and (not DUF_OPTIONS_VISIBLE)) then
			_G[StatusBar:GetName().."_TargetManaBar"]:SetAlpha(0)
			return
		elseif (not BAR_SETTINGS.hide) then
			_G[StatusBar:GetName().."_TargetManaBar"]:SetAlpha(BAR_SETTINGS.alpha)
			StatusBar.manatarget = 0
			StatusBar.manamaxtarget = 0
		else
			return
		end
	end
	if (not StatusBar.unit) then return end
	if ((not DL_UnitName(StatusBar.unit.."target")) and (not DUF_OPTIONS_VISIBLE)) then
		_G[StatusBar:GetName().."_TargetManaBar"]:SetAlpha(0)
		return
	elseif (not BAR_SETTINGS.hide) then
		_G[StatusBar:GetName().."_TargetManaBar"]:SetAlpha(BAR_SETTINGS.alpha)
	end
	local value 
	if StatusBar.manamaxtarget == 0 then
		value = 100
	else
		value = StatusBar.manatarget / StatusBar.manamaxtarget * 100
	end
--	if (StatusBar.manamaxtarget == 0) then
--		value = 100
--	end
	if (BAR_SETTINGS.fill) then
		NS:StatusBar_SetValue(_G[StatusBar:GetName().."_TargetManaBar"].Bar1, 100 - value, 1, BAR_SETTINGS.width)
		NS:StatusBar_SetValue(_G[StatusBar:GetName().."_TargetManaBar"].Bar2, 0, 1, BAR_SETTINGS.width)
	else
		NS:StatusBar_SetValue(_G[StatusBar:GetName().."_TargetManaBar"].Bar1, value, 1, BAR_SETTINGS.width)
		NS:StatusBar_SetValue(_G[StatusBar:GetName().."_TargetManaBar"].Bar2, 0, 1, BAR_SETTINGS.width)
	end
end

function NS:DUF_TargetManaBar_UpdateType(StatusBar)
	local color
	if (StatusBar.manatypetarget == 0) then
		color = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[StatusBar.unit].index].StatusBar[NS.Bar.TargetPower].manacolor
	elseif (StatusBar.manatypetarget == 1) then
		color = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[StatusBar.unit].index].StatusBar[NS.Bar.TargetPower].ragecolor
	elseif (StatusBar.manatypetarget == 2) then
		color = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[StatusBar.unit].index].StatusBar[NS.Bar.TargetPower].focuscolor
	elseif (StatusBar.manatypetarget == 3) then
		color = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[StatusBar.unit].index].StatusBar[NS.Bar.TargetPower].energycolor
	elseif (StatusBar.manatypetarget == 6) then
		color = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[StatusBar.unit].index].StatusBar[NS.Bar.TargetPower].runicpowercolor
	end
	if (color) then
		_G[StatusBar:GetName().."_TargetManaBar"].manacolor = color
		_G[StatusBar:GetName().."_TargetManaBar"].Bar1:SetVertexColor(color.r, color.g, color.b)
	end
end

function NS:DUF_XPBar_Update()
	if (DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.XP].trackRep) then
		DUF_ReputationBar_Update(1)
		return
	end
	local percent = UnitXP("player") / UnitXPMax("player") * 100
	if (UnitXPMax("player") == 0) then
		percent = 0
	end
	local bonusxp = GetXPExhaustion()
	local bonusxp2 = 0
	if (bonusxp) then
		bonusxp2 = bonusxp
		bonusxp = mathfloor(bonusxp / 2)
	else
		bonusxp = 0
	end
	local bonuspercent = (UnitXP("player") + bonusxp2)/ UnitXPMax("player") * 100
	if (UnitXPMax("player") == 0) then
		bonuspercent = 0
	end
	if (bonuspercent > 100) then
		bonuspercent = 100
	end
	local Width = DUF_Settings[DUF_INDEX].player.StatusBar[NS.Bar.XP].width
	NS:StatusBar_SetValue(DUF_PlayerFrame_XPBar.Bar1, percent, 1, Width)
	NS:StatusBar_SetValue(DUF_PlayerFrame_XPBar.Bar2, bonuspercent, 1, Width)
end

function NS:DUF_CastBar_Update(StatusBar)
	local BAR_SETTINGS = DUF_Settings[DUF_INDEX][DUF_FRAME_DATA[StatusBar.unit].index].StatusBar[NS.Bar.Cast]
	local time = GetTime()*1000
	local value = 100
	_G[StatusBar:GetName().."_CastBar"].Bar1:Show()
	if ((not StatusBar.cast)) then
		if (BAR_SETTINGS.hideifnocast and (not DUF_OPTIONS_VISIBLE)) then
			_G[StatusBar:GetName().."_CastBar"]:SetAlpha(0)
			return
		else
			if ((not BAR_SETTINGS.hide) and (not BAR_SETTINGS.mouseover)) then
				_G[StatusBar:GetName().."_CastBar"]:SetAlpha(BAR_SETTINGS.alpha)
			else
				return
			end
			if (DUF_OPTIONS_VISIBLE) then
				StatusBar.cast = "preview"
				StatusBar.caststartTime = time
				StatusBar.castendTime = time
			else
				StatusBar.cast = nil
				StatusBar.caststartTime = 0
				StatusBar.castendTime = 0
			end
		end
	elseif ((not BAR_SETTINGS.hide) and (not BAR_SETTINGS.mouseover)) then
		_G[StatusBar:GetName().."_CastBar"]:SetAlpha(BAR_SETTINGS.alpha)
	end

	if ( StatusBar.castendTime and time > StatusBar.castendTime ) then
		time = StatusBar.endTime
	end
	if ( StatusBar.castendTime and (time == StatusBar.castendTime) ) then
		StatusBar.caststartTime = 100
		StatusBar.castendTime = 100
	end
	if (StatusBar.cast and StatusBar.caststartTime and StatusBar.castendTime and time) then
		if StatusBar.castendTime - StatusBar.caststartTime == 0 then
			value = (StatusBar.castendTime - time) * 100
		else
			value = ((StatusBar.castendTime - time) / (StatusBar.castendTime - StatusBar.caststartTime)) * 100
		end
	end
	local value2 = 0
	if (BAR_SETTINGS.fade and value > 0) then
		value2 = StatusBar.lastcastvalue
		if StatusBar.stacked then
			value2 = value2 - value
		end
	end
	StatusBar.lastcastvalue = value

	local width = BAR_SETTINGS.width
	if (not BAR_SETTINGS.castisChanneling) then
		NS:StatusBar_SetValue(_G[StatusBar:GetName().."_CastBar"].Bar1, 100 - value, 1, width)
		NS:StatusBar_SetValue(_G[StatusBar:GetName().."_CastBar"].Bar2, 0, 1, width)
	else
		NS:StatusBar_SetValue(_G[StatusBar:GetName().."_CastBar"].Bar1, value, 1, width)
		NS:StatusBar_SetValue(_G[StatusBar:GetName().."_CastBar"].Bar2, value2, 1, width)
	end
end

